#include-once

Opt('OnExitFunc', 'CloseDllHandles')

Global $gdi32dll		=	DllOpen('gdi32.dll')
Global $user32dll		=	DllOpen('user32.dll')
Global $shell32dll		=	DllOpen('shell32.dll')
Global $kernel32dll		=	DllOpen('kernel32.dll')

Func CloseDllHandles()
	
	DllClose($gdi32dll)
	DllClose($user32dll)
	DllClose($shell32dll)
	DllClose($kernel32dll)
	
EndFunc


;/////////////////////////////////////////////////////////////
;//						Konstanten							//
;/////////////////////////////////////////////////////////////

If Not IsDeclared ('NULL') Then Global Const $NULL = Ptr(0)

; Fensterstile
Global Const $WS_EX_COMPOSITED = 0x2000000

; Fensterklassenstile
Global Const $CS_VREDRAW = 0x0001
Global Const $CS_HREDRAW = 0x0002

Global Const $CW_USEDEFAULT = 0x80000000

Global Const $LOCALE_USER_DEFAULT = 0x400
Global Const $LOCALE_ITIME = 35
Global Const $LOCALE_ITLZERO = 0x00000025

; /* Mapping Modes */
Global Const $MM_TEXT            = 1
Global Const $MM_LOMETRIC        = 2
Global Const $MM_HIMETRIC        = 3
Global Const $MM_LOENGLISH       = 4
Global Const $MM_HIENGLISH       = 5
Global Const $MM_TWIPS           = 6
Global Const $MM_ISOTROPIC       = 7
Global Const $MM_ANISOTROPIC     = 8


; Icon
Global Const $IDI_APPLICATION = 32512
; Cursor
Global Const $IDC_ARROW = MAKEINTRESOURCE(32512)

Global Const $WHITE_BRUSH         = 0
Global Const $LTGRAY_BRUSH        = 1
Global Const $GRAY_BRUSH          = 2
Global Const $DKGRAY_BRUSH        = 3
Global Const $BLACK_BRUSH         = 4
Global Const $NULL_BRUSH          = 5
Global Const $HOLLOW_BRUSH        = 5
Global Const $WHITE_PEN           = 6
Global Const $BLACK_PEN           = 7
Global Const $NULL_PEN            = 8
Global Const $SYSTEM_FONT         = 13
Global Const $DEFAULT_PALETTE     = 15
Global Const $ANSI_FIXED_FONT     = 11
Global Const $ANSI_VAR_FONT       = 12
Global Const $DEVICE_DEFAULT_FONT = 14
;Global Const $DEFAULT_GUI_FONT    = 17
Global Const $OEM_FIXED_FONT      = 10
Global Const $SYSTEM_FIXED_FONT   = 16

;/////////////////////////////////////////////////////////////
;//						Strukturen							//
;/////////////////////////////////////////////////////////////

Global	$tagWNDCLASSEX			=	'uint cbSize;' & _
									'uint style;' & _
									'ptr  lpfnWndProc;' & _
									'int  cbClsExtra;' & _
									'int  cbWndExtra;' & _
									'ptr  hInstance;' & _
									'ptr  hIcon;' & _
									'ptr  hCursor;' & _
									'ptr  hbrBackground;' & _
									'ptr  lpszMenuName;' & _
									'ptr  lpszClassName;' & _
									'ptr  hIconSm;'
;
Global  $tagMSG					=	'hwnd  hwnd;' & _
									'uint  message;' & _
									'uint  wParam;' & _
									'long  lParam;' & _
									'dword time;' & _
									'long;long;'	; POINT pt;
;
Global  $tagPOINT				=	'long x;' & _
									'long y;'
;
Global	$tagRECT				=	'long left;' & _
									'long top;' & _
									'long right;' & _
									'long bottom;'
;

Global	$tagPAINTSTRUCT			=	'hwnd hDC;' & _
									'int  fErase;' & _
									'long rcPaint[4];' & _
									'int  fRestore;' & _
									'int  fIncUpdate;' & _
									'byte rgbReserved[32]'
;
Global $tagSYSTEMTIME 			= 	'short Year;' & _
									'short Month;'& _
									'short Dow;' & _
									'short Day;'& _
									'short Hour;' & _
									'short Minute;' & _
									'short Second;' & _
									'short MSeconds;'
;
Global $tagSIZE					=	'int cx;' & _
									'int cy;'
;
;/////////////////////////////////////////////////////////////
;//						API Funktionen						//
;/////////////////////////////////////////////////////////////
Func Polygon ($hdc, $lpPoints, $nCount)

	Local $aRes = DllCall ($gdi32dll, 'int', 'Polygon', _
											 'ptr', $hdc, _
											 'ptr', $lpPoints, _
											 'int', $nCount)
	Return $aRes[0]

EndFunc

Func OffsetWindowOrgEx ($hdc, $nXOffset, $nYOffset, $lpPoint)

	Local $aRes = DllCall ($gdi32dll, 'int', 'OffsetWindowOrgEx', _
											 'ptr', $hdc, _
											 'int', $nXOffset, _
											 'int', $nYOffset, _
											 'ptr', $lpPoint)
	Return $aRes[0]

EndFunc

Func GetLocalTime ($pSystemTime)

	Local $aRes = DllCall ($kernel32dll, 'none', 'GetLocalTime', 'ptr', $pSystemTime)
	Return $aRes[0]

EndFunc

Func GetLocaleInfo ($Locale, $LCType, ByRef $lpLCData, $cchData)

	Local $aRes = DllCall ($kernel32dll, 'int', 'GetLocaleInfo', _
												'dword', $Locale, _
												'dword', $LCType, _
												'ptr',   $lpLCData, _
												'int',   $cchData)
	Return $aRes[0]

EndFunc

Func SetMapMode ($hdc, $fnMapMode)

	Local $aRes = DllCall ($gdi32dll, 'int', 'SetMapMode', _
											 'ptr', $hdc, _
											 'int', $fnMapMode)
	Return $aRes[0]

EndFunc

Func SetViewportExtEx ($hdc, $nXExtent, $nYExtent, $lpSize)

	Local $aRes = DllCall ($gdi32dll, 'int', 'SetViewportExtEx', _
											 'ptr', $hdc, _      ; // handle to device context
											 'int', $nXExtent, _ ; // new horizontal viewport extent
											 'int', $nYExtent, _ ; // new vertical viewport extent
											 'ptr', $lpSize)     ; // original viewport extent
	Return $aRes[0]

EndFunc

Func SetViewportOrgEx ($hdc, $X, $Y, $lpPoint)

	Local $aRes = DllCall ($gdi32dll, 'int', 'SetViewportOrgEx', _
											 'ptr', $hdc, _      ; // handle to device context
											 'int', $X, _        ; // new x-coordinate of viewport origin
											 'int', $Y, _        ; // new y-coordinate of viewport origin
											 'ptr', $lpPoint)    ; // original viewport origin
	Return $aRes[0]

EndFunc

Func SetWindowExtEx ($hdc, $nXExtent, $nYExtent, $lpSize)

	Local $aRes = DllCall ($gdi32dll, 'int', 'SetWindowExtEx', _
											 'ptr', $hdc, _      ; // handle to device context
											 'int', $nXExtent, _ ; // new horizontal window extent
											 'int', $nYExtent, _ ; // new vertical window extent
											 'ptr', $lpSize)     ; // original viewport extent
	Return $aRes[0]

EndFunc

Func SetWindowOrgEx($hdc, $X, $Y, $lpPoint)

	Local $aRes = DllCall ($gdi32dll, 'int', 'SetWindowOrgEx', _
											 'ptr', $hdc, _      ; // handle to device context
											 'int', $X, _        ; // new x-coordinate of window origin
											 'int', $Y, _        ; // new y-coordinate of window origin
											 'ptr', $lpPoint)    ; // original viewport origin
	Return $aRes[0]

EndFunc

Func BeginPaint($hWnd, ByRef $lpPaint)
	
	Local $aResult = DllCall($user32dll, 'hwnd', 'BeginPaint', 'hwnd', $hWnd, 'ptr', $lpPaint)
	Return $aResult[0]
	
EndFunc

Func CreateWindowEx($iExStyle, $sClassName, $sWindowName, $iStyle, $iX, $iY, $iWidth, $iHeight, $hWndParent = 0, $hMenu = 0, $hInstance = 0, $pParam = 0)   
	
    If $hInstance = 0 Then $hInstance = GetModuleHandle($NULL)
	Local $aResult = DllCall($user32dll, 'hwnd', 'CreateWindowEx', _
													'int' , $iExStyle, _
													'str',  $sClassName, _
													'str',  $sWindowName, _
													'int',  $iStyle, _
													'int',  $iX, _
													'int',  $iY, _
													'int',  $iWidth, _
													'int',  $iHeight, _
													'hwnd', $hWndParent, _
													'ptr',  $hMenu, _
													'ptr',  $hInstance, _
													'ptr',  $pParam)
	Return $aResult[0]
	
EndFunc

Func CreateSolidBrush($crColor)

	Local $aRes = DllCall ($gdi32dll, 'ptr', 'CreateSolidBrush', _
											 'dword', $crColor)  ; // brush color value
	Return $aRes [0]

EndFunc

Func EndPaint($hWnd, ByRef $lpPaint)
	
	Local $aResult = DllCall($user32dll, 'int', 'EndPaint', 'hwnd', $hWnd, 'ptr', $lpPaint)
	Return $aResult[0]
	
EndFunc

Func DefWindowProc($hWnd, $nMsg, $wParam, $lParam)
	
	Local $aResult
	$aResult = DllCall($user32dll, 'int', 'DefWindowProc', _
											'hwnd', $hWnd, _
											'int',  $nMsg, _
											'uint', $wParam, _
											'long', $lParam)
	Return $aResult[0]
	
EndFunc

Func DeleteObject($hGdiObj)
	
	Local $aResult = DllCall($gdi32dll, 'int', 'DeleteObject', 'ptr', $hGdiObj)
	Return $aResult[0]
	
EndFunc

Func DestroyWindow($hWnd)
	
	Local $aResult = DllCall($user32dll, 'int', 'DestroyWindow', 'hwnd', $hWnd)
	Return $aResult[0]
	
EndFunc
	
Func DispatchMessage(ByRef $lpMsg)
	
	Local $aResult = DllCall($user32dll, 'long', 'DispatchMessage', 'ptr', $lpMsg)
	Return $aResult
	
EndFunc

Func DrawText($hdc, $lpString, $nCount, ByRef $lpRect, $uFormat)

	Local $aResult
	$aResult = DllCall($user32dll, 'int', 'DrawText', _
										  'ptr',  $hdc, _
										  'str',  $lpString, _
										  'int',  $nCount, _
										  'ptr',  $lpRect, _
										  'uint', $uFormat)
	Return $aResult[0]

EndFunc

Func GetMessage(ByRef $lpMsg, $hWnd, $wMsgFilterMin, $wMsgFilterMax)
	
	Local $aResult = DllCall($user32dll, 'int', 'GetMessage', _
												'ptr',  $lpMsg, _
												'hwnd', $hWnd, _
												'uint', $wMsgFilterMin, _
												'uint', $wMsgFilterMax)
    Return $aResult[0]
	
EndFunc

Func GetClientRect($hWnd, ByRef $lpRect)
	
	Local $arResult = DllCall($user32dll, 'int', 'GetClientRect', 'hwnd', $hWnd, 'ptr', $lpRect)
	Return $arResult[0]
	
EndFunc

Func GetModuleHandle($sModuleName)
	
	Local $tText, $aResult

	If $sModuleName <> "" Then
		$tText = DllStructCreate("char Text[4096]")
		DllStructSetData($tText, "Text", $sModuleName)
		$aResult = DllCall($kernel32dll, "hwnd", "GetModuleHandle", "ptr", DllStructGetPtr($tText))
	Else
		$aResult = DllCall($kernel32dll, "hwnd", "GetModuleHandle", "ptr", $NULL)
	EndIf
	Return $aResult[0]
	
EndFunc

Func GetStockObject($iObject)
	
	Local $aResult = DllCall($gdi32dll, 'hwnd', 'GetStockObject', 'int', $iObject)
	Return $aResult[0]
	
EndFunc

Func InvalidateRect($hWnd, $lpRect = 0, $bErase = True)
  
  Local $aResult = DllCall($user32dll, 'int', 'InvalidateRect', _
											  'hwnd', $hWnd, _
											  'ptr',  $lpRect, _
											  'int',  $bErase)
	Return $aResult[0]
  
EndFunc

Func KillTimer ($hwnd, $uIDEvent)

	Local $aRes = DllCall ($user32dll, 'int', 'KillTimer', _
											  'hwnd', $hwnd, _
											  'uint', $uIDEvent)

	Return $aRes [0]

EndFunc

Func LoadCursor($hInstance, $szCursorName)
	
	If IsNumber($szCursorName) Then $szCursorName = MAKEINTRESOURCE($szCursorName)
	Local $aResult = DllCall($user32dll, 'ptr', 'LoadCursor', 'ptr', $hInstance, 'str', $szCursorName)
	Return $aResult[0]
	
EndFunc

Func LoadIcon($hInstance, $szIconName)
	
	If IsNumber($szIconName) Then $szIconName = MAKEINTRESOURCE($szIconName)
	Local $aResult = DllCall($user32dll, 'ptr', 'LoadIcon', 'ptr', $hInstance, 'str', $szIconName)
	Return $aResult[0]
	
EndFunc

Func PostQuitMessage($nExitCode = 0)
	
	Local $aResult = DllCall($user32dll, 'none', 'PostQuitMessage', 'int', $nExitCode)
	Return $aResult[0]	
	
EndFunc

Func RegisterClassEx(ByRef $lpwcx)
	
	Local $aResult = DllCall($user32dll, 'dword', 'RegisterClassEx', 'ptr', $lpwcx)
	Return $aResult[0]
	
EndFunc

Func ShowWindow($hWnd, $nCmdShow = 5)
	
	Local $aResult = DllCall($user32dll, 'int', 'ShowWindow', 'hwnd', $hWnd, 'int', $nCmdShow)
	Return $aResult[0]
	
EndFunc

Func SelectObject ($hdc, $hGdiObj)
	
	Local $aRes = DllCall ($gdi32dll, 'ptr', 'SelectObject', _
											  'ptr', $hdc, _
											  'ptr', $hGdiObj)
	Return $aRes [0]

EndFunc

Func SetTimer ($hwnd, $uIDEvent, $uElapse, $lpTimerFunc)

	Local $aRes = DllCall ($user32dll, 'int', 'SetTimer', _
											  'hwnd', $hwnd, _
											  'uint', $uIDEvent, _
											  'uint', $uElapse, _
											  'ptr',  $lpTimerFunc)
	Return $aRes [0]

EndFunc

Func UpdateWindow($hWnd)
	
	Local $aResult = DllCall($user32dll, 'int', 'UpdateWindow', 'hwnd', $hWnd)
	Return $aResult[0]
	
EndFunc

Func TranslateMessage(ByRef $lpMsg)
	
	Local $aResult = DllCall($user32dll, 'int', 'TranslateMessage', 'ptr', $lpMsg)
	Return $aResult[0]
	
EndFunc


;/////////////////////////////////////////////////////////////
;//						Makro Funktionen					//
;/////////////////////////////////////////////////////////////
Func LOWORD ($DWORD)
	Return BitAND($DWORD, 0xFFFF)
EndFunc

Func HIWORD ($DWORD)
	Return BitShift($DWORD, 16)
EndFunc

Func MAKEINTRESOURCE ($lID)	
	Return "#" & String(Int($lID))	
EndFunc

Func RGB ($red, $green, $blue)
	Return ('0x00' & Hex ($blue, 2) & Hex ($green, 2) & Hex ($red, 2)) ; BGR
EndFunc


